<?php
namespace Modules\Cadastros\Controllers; 

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\Controller;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DTO\Response\Notification;
use Zeedhi\Framework\Report\ReportService;

class Cmp01200CompradorController extends \Zeedhi\Framework\Controller\Report
{
    protected $dataSourceName = "filial_cdfilcentcmp";
    protected $qr2Strategy;
    protected $birtStrategy;
    protected $stNomeRel;
    protected $stExtensao;
    protected $newCode;
    protected $environment;
    protected $entityManager;
    protected $connection;
    protected $dataSourceManager;
    private $supUtilities;

    
    public function __construct($reportService, $entityManager, $qr2Strategy,$birtStrategy, $newCode, $environment, $connection, $dataSourceManager) 
    {
        parent::__construct($reportService);
        $this->entityManager     = $entityManager;
        $this->qr2Strategy       = $qr2Strategy;
        $this->birtStrategy      = $birtStrategy;
        $this->reportService     = $reportService;
        $this->newCode           = $newCode;
        $this->environment       = $environment;
        $this->connection        = $connection;
        $this->dataSourceManager = $dataSourceManager;
    }
    private function strPadRigthProd($value){
	    return str_pad($value, 20, 'Z', STR_PAD_RIGHT);
	}
    public function cadastramentoAutomatico(DTO\Request\Row $request, DTO\Response $response){
        try{
            $row = $request->getRow();
            $sql = "SELECT NVL(CDFILCENTCMP, CDFILIAL) AS CDFILCENTCMP FROM FILIAL WHERE (CDFILIAL = :P_CDFILIAL)";
            $params = array();
            $params['P_CDFILIAL'] = $row['CDFILIAL'];
            $stmt = $this->con->prepare($sql);
            $stmt->execute($params);
            $result = $stmt->fetchAll();
            
            $sql = "SELECT IDUMPRODCMP FROM PARASUPRI WHERE CDFILIAL = :P_CDFILIAL";
            $params['P_CDFILIAL'] = $result[0]['CDFILCENTCMP'];
            $stmt = $this->con->prepare($sql);
            $stmt->execute($params);
            $result = $stmt->fetchAll();
                
            if (is_array($result) && count($result)) {    
                $params['P_CDFILIAL'] = $row['CDFILIAL'];
                $params['P_CDOPERADOR'] = $row['CDOPERADOR'];
                $params['P_CDPRODUTOINI'] = $row['CDPRODINI'];
                $params['P_CDPRODUTOFIN'] = $row['CDPRODFIN'] = self::strPadRigthProd($row['CDPRODFIN']);
            
                if($result[0]['IDUMPRODCMP'] === 'S') {
                    $verificacao = "SELECT PRODUTO.CDPRODUTO FROM (SELECT PRODUTO.*, 'SEG' AS IDTPPRODUTO FROM NIVELPRODSEG, PRODUTO, FILIAL, PRODUTO P WHERE P.CDPRODUTO = NIVELPRODSEG.CDPRODUTO AND FILIAL.CDSEGMER = NIVELPRODSEG.CDSEGMER AND FILIAL.CDFILIAL = :P_CDFILIAL AND PRODUTO.CDARVPROD LIKE P.CDARVPROD || '%' AND NOT EXISTS (SELECT CDPRODUTO FROM ROTFABRICA WHERE ROTFABRICA.CDPRODUTO = PRODUTO.CDPRODUTO) AND NOT EXISTS (SELECT CDPRODUTO FROM ROTFABLOCAL WHERE CDFILIAL = :P_CDFILIAL AND ROTFABLOCAL.CDPRODUTO = PRODUTO.CDPRODUTO) UNION ALL SELECT PRODUTO.*, 'PROD' AS IDTPPRODUTO FROM FILIAL, PRODUTO WHERE FILIAL.CDSEGMER IS NULL AND FILIAL.CDFILIAL = :P_CDFILIAL AND NOT EXISTS (SELECT CDPRODUTO FROM ROTFABRICA WHERE ROTFABRICA.CDPRODUTO = PRODUTO.CDPRODUTO) AND NOT EXISTS (SELECT CDPRODUTO FROM ROTFABLOCAL WHERE CDFILIAL = :P_CDFILIAL AND ROTFABLOCAL.CDPRODUTO = PRODUTO.CDPRODUTO)) PRODUTO WHERE PRODUTO.CDARVPROD BETWEEN :P_CDPRODUTOINI AND :P_CDPRODUTOFIN AND PRODUTO.CDPRODESTO IS NOT NULL AND (NOT EXISTS (SELECT PRODCOMP.CDPRODUTO FROM PRODUTO A, PRODCOMP WHERE A.CDPRODUTO = PRODCOMP.CDPRODUTO AND PRODCOMP.CDOPERADOR = :P_CDOPERADOR AND PRODUTO.CDARVPROD LIKE A.CDARVPROD || '%')) AND (NOT EXISTS (SELECT PRODCOMP.CDOPERADOR FROM PRODUTO A, PRODCOMP WHERE A.CDPRODUTO = PRODCOMP.CDPRODUTO AND (PRODUTO.CDARVPROD LIKE A.CDARVPROD || '%' OR A.CDARVPROD LIKE PRODUTO.CDARVPROD || '%') AND PRODCOMP.CDOPERADOR <> :P_CDOPERADOR UNION SELECT PRODCOMP.CDOPERADOR FROM PRODUTO PROD, PRODCOMP WHERE ((PROD.CDPRODUTO = PRODUTO.CDPRODUTO AND PROD.CDPRODESTO = PRODCOMP.CDPRODUTO) OR (PROD.CDPRODESTO = PRODUTO.CDPRODUTO AND PROD.CDPRODUTO = PRODCOMP.CDPRODUTO)) AND PRODCOMP.CDOPERADOR <> :P_CDOPERADOR))";
                    $stmt = $this->con->prepare($verificacao);
                    $stmt->execute($params);
                    $retornaVericacao = $stmt->fetchAll();
                    
                    if (is_array($retornaVericacao) && count($retornaVericacao)) {
                        $sql = "INSERT INTO PRODCOMP(CDOPERADOR,CDPRODUTO) SELECT :P_CDOPERADOR, PRODUTO.CDPRODUTO FROM (SELECT PRODUTO.*, 'SEG' AS IDTPPRODUTO FROM NIVELPRODSEG, PRODUTO, FILIAL, PRODUTO P WHERE P.CDPRODUTO = NIVELPRODSEG.CDPRODUTO AND FILIAL.CDSEGMER = NIVELPRODSEG.CDSEGMER AND FILIAL.CDFILIAL = :P_CDFILIAL AND PRODUTO.CDARVPROD LIKE P.CDARVPROD || '%' AND NOT EXISTS (SELECT CDPRODUTO FROM ROTFABRICA WHERE ROTFABRICA.CDPRODUTO = PRODUTO.CDPRODUTO) AND NOT EXISTS (SELECT CDPRODUTO FROM ROTFABLOCAL WHERE CDFILIAL = :P_CDFILIAL AND ROTFABLOCAL.CDPRODUTO = PRODUTO.CDPRODUTO) UNION ALL SELECT PRODUTO.*, 'PROD' AS IDTPPRODUTO FROM FILIAL, PRODUTO WHERE FILIAL.CDSEGMER IS NULL AND FILIAL.CDFILIAL = :P_CDFILIAL AND NOT EXISTS (SELECT CDPRODUTO FROM ROTFABRICA WHERE ROTFABRICA.CDPRODUTO = PRODUTO.CDPRODUTO) AND NOT EXISTS (SELECT CDPRODUTO FROM ROTFABLOCAL WHERE CDFILIAL = :P_CDFILIAL AND ROTFABLOCAL.CDPRODUTO = PRODUTO.CDPRODUTO)) PRODUTO WHERE PRODUTO.CDARVPROD BETWEEN :P_CDPRODUTOINI AND :P_CDPRODUTOFIN AND PRODUTO.CDPRODESTO IS NOT NULL AND (NOT EXISTS (SELECT PRODCOMP.CDPRODUTO FROM PRODUTO A, PRODCOMP WHERE A.CDPRODUTO = PRODCOMP.CDPRODUTO AND PRODCOMP.CDOPERADOR = :P_CDOPERADOR AND PRODUTO.CDARVPROD LIKE A.CDARVPROD || '%')) AND (NOT EXISTS (SELECT PRODCOMP.CDOPERADOR FROM PRODUTO A, PRODCOMP WHERE A.CDPRODUTO = PRODCOMP.CDPRODUTO AND (PRODUTO.CDARVPROD LIKE A.CDARVPROD || '%' OR A.CDARVPROD LIKE PRODUTO.CDARVPROD || '%') AND PRODCOMP.CDOPERADOR <> :P_CDOPERADOR UNION SELECT PRODCOMP.CDOPERADOR FROM PRODUTO PROD, PRODCOMP WHERE ((PROD.CDPRODUTO = PRODUTO.CDPRODUTO AND PROD.CDPRODESTO = PRODCOMP.CDPRODUTO) OR (PROD.CDPRODESTO = PRODUTO.CDPRODUTO AND PROD.CDPRODUTO = PRODCOMP.CDPRODUTO)) AND PRODCOMP.CDOPERADOR <> :P_CDOPERADOR))";
                    } else {
                        throw new \Exception('Não foi possivel fazer a inserção do intervalo de produtos informados.');
                    }
                 } else {
                     $verificacao="SELECT PRODUTO.CDPRODUTO FROM (SELECT PRODUTO.*, 'SEG' AS IDTPPRODUTO FROM NIVELPRODSEG, PRODUTO, FILIAL, PRODUTO P WHERE P.CDPRODUTO = NIVELPRODSEG.CDPRODUTO AND FILIAL.CDSEGMER = NIVELPRODSEG.CDSEGMER AND FILIAL.CDFILIAL = :P_CDFILIAL AND PRODUTO.CDARVPROD LIKE P.CDARVPROD || '%' AND NOT EXISTS (SELECT CDPRODUTO FROM ROTFABRICA WHERE ROTFABRICA.CDPRODUTO = PRODUTO.CDPRODUTO) AND NOT EXISTS (SELECT CDPRODUTO FROM ROTFABLOCAL WHERE CDFILIAL = :P_CDFILIAL AND ROTFABLOCAL.CDPRODUTO = PRODUTO.CDPRODUTO) UNION ALL SELECT PRODUTO.*, 'PROD' AS IDTPPRODUTO FROM FILIAL, PRODUTO WHERE FILIAL.CDSEGMER IS NULL AND FILIAL.CDFILIAL = :P_CDFILIAL AND NOT EXISTS (SELECT CDPRODUTO FROM ROTFABRICA WHERE ROTFABRICA.CDPRODUTO = PRODUTO.CDPRODUTO) AND NOT EXISTS (SELECT CDPRODUTO FROM ROTFABLOCAL WHERE CDFILIAL = :P_CDFILIAL AND ROTFABLOCAL.CDPRODUTO = PRODUTO.CDPRODUTO)) PRODUTO WHERE PRODUTO.CDARVPROD BETWEEN :P_CDPRODUTOINI AND :P_CDPRODUTOFIN AND PRODUTO.CDPRODESTO IS NOT NULL AND (NOT EXISTS (SELECT PRODCOMP.CDPRODUTO FROM PRODCOMP, PRODUTO A WHERE A.CDPRODUTO = PRODCOMP.CDPRODUTO AND PRODCOMP.CDOPERADOR = :P_CDOPERADOR AND PRODUTO.CDARVPROD LIKE A.CDARVPROD || '%'))";
                     $stmt = $this->con->prepare($verificacao);
                     $stmt->execute($params);
                     $retornaVericacao = $stmt->fetchAll();
                     if (is_array($retornaVericacao) && count($retornaVericacao)) {
                         $sql = "INSERT INTO PRODCOMP(CDOPERADOR,CDPRODUTO) SELECT SUBSTR(:P_CDOPERADOR,1,255) AS CDOPERADOR, PRODUTO.CDPRODUTO FROM (SELECT PRODUTO.*, 'SEG' AS IDTPPRODUTO FROM NIVELPRODSEG, PRODUTO, FILIAL, PRODUTO P WHERE P.CDPRODUTO = NIVELPRODSEG.CDPRODUTO AND FILIAL.CDSEGMER = NIVELPRODSEG.CDSEGMER AND FILIAL.CDFILIAL = :P_CDFILIAL AND PRODUTO.CDARVPROD LIKE P.CDARVPROD || '%' AND NOT EXISTS (SELECT CDPRODUTO FROM ROTFABRICA WHERE ROTFABRICA.CDPRODUTO = PRODUTO.CDPRODUTO) AND NOT EXISTS (SELECT CDPRODUTO FROM ROTFABLOCAL WHERE CDFILIAL = :P_CDFILIAL AND ROTFABLOCAL.CDPRODUTO = PRODUTO.CDPRODUTO) UNION ALL SELECT PRODUTO.*, 'PROD' AS IDTPPRODUTO FROM FILIAL, PRODUTO WHERE FILIAL.CDSEGMER IS NULL AND FILIAL.CDFILIAL = :P_CDFILIAL AND NOT EXISTS (SELECT CDPRODUTO FROM ROTFABRICA WHERE ROTFABRICA.CDPRODUTO = PRODUTO.CDPRODUTO) AND NOT EXISTS (SELECT CDPRODUTO FROM ROTFABLOCAL WHERE CDFILIAL = :P_CDFILIAL AND ROTFABLOCAL.CDPRODUTO = PRODUTO.CDPRODUTO)) PRODUTO WHERE PRODUTO.CDARVPROD BETWEEN :P_CDPRODUTOINI AND :P_CDPRODUTOFIN AND PRODUTO.CDPRODESTO IS NOT NULL AND (NOT EXISTS (SELECT PRODCOMP.CDPRODUTO FROM PRODCOMP, PRODUTO A WHERE A.CDPRODUTO = PRODCOMP.CDPRODUTO AND PRODCOMP.CDOPERADOR = :P_CDOPERADOR AND PRODUTO.CDARVPROD LIKE A.CDARVPROD || '%'))";
                         
                     } else {
                         throw new \Exception('Não foi possivel fazer a inserção do intervalo de produtos informados.');
                     }
                }
                $stmt = $this->con->prepare($sql);
                $stmt->execute($params);
                
            } else {
                throw new \Exception('Central de Compras da unidade sem parametrização!');
            }
        } catch(Exception $e){
            $response->setError($e->getMessage());
        }
    }
    public function cadastramentoAutomaticoLPP(DTO\Request\Row $request, DTO\Response $response){
        $row = $request->getRow();
        
        $params = array();
        $params['P_CDFILIAL'] = $row['CDFILIAL'];
        $params['P_CDOPERADOR'] = $row['CDOPERADOR'];
        $params['P_CDPRODUTOINI'] = $row['CDPRODINI'];
        $params['P_CDPRODUTOFIN'] = $row['CDPRODFIN'] = self::strPadRigthProd($row['CDPRODFIN']);
        $params['P_VRLIMPRODAF'] = $row['VRLIMPRODAF'];
        $params['P_VRLIMPRAFMES'] = $row['VRLIMPRAFMES'];
        $verificacao="SELECT SUBSTR(:P_CDOPERADOR,1,255) AS CDOPERADOR, PRODUTO.CDPRODUTO, :P_VRLIMPRODAF, :P_VRLIMPRAFMES FROM (SELECT PRODUTO.*, 'SEG' AS IDTPPRODUTO FROM NIVELPRODSEG, PRODUTO, FILIAL, PRODUTO P WHERE P.CDPRODUTO = NIVELPRODSEG.CDPRODUTO AND FILIAL.CDSEGMER = NIVELPRODSEG.CDSEGMER AND FILIAL.CDFILIAL = :P_CDFILIAL AND PRODUTO.CDARVPROD LIKE P.CDARVPROD || '%' AND NOT EXISTS (SELECT CDPRODUTO FROM ROTFABRICA WHERE ROTFABRICA.CDPRODUTO = PRODUTO.CDPRODUTO) AND NOT EXISTS (SELECT CDPRODUTO FROM ROTFABLOCAL WHERE CDFILIAL = :P_CDFILIAL AND ROTFABLOCAL.CDPRODUTO = PRODUTO.CDPRODUTO) UNION ALL SELECT PRODUTO.*, 'PROD' AS IDTPPRODUTO FROM FILIAL, PRODUTO WHERE FILIAL.CDSEGMER IS NULL AND FILIAL.CDFILIAL = :P_CDFILIAL AND NOT EXISTS (SELECT CDPRODUTO FROM ROTFABRICA WHERE ROTFABRICA.CDPRODUTO = PRODUTO.CDPRODUTO) AND NOT EXISTS (SELECT CDPRODUTO FROM ROTFABLOCAL WHERE CDFILIAL = :P_CDFILIAL AND ROTFABLOCAL.CDPRODUTO = PRODUTO.CDPRODUTO)) PRODUTO WHERE PRODUTO.CDARVPROD BETWEEN :P_CDPRODUTOINI AND :P_CDPRODUTOFIN AND PRODUTO.CDPRODESTO IS NOT NULL AND (EXISTS (SELECT PRODCOMP.CDPRODUTO FROM PRODCOMP, PRODUTO A WHERE A.CDPRODUTO = PRODCOMP.CDPRODUTO AND PRODCOMP.CDOPERADOR = :P_CDOPERADOR AND PRODUTO.CDARVPROD LIKE A.CDARVPROD || '%')) AND (NOT EXISTS (SELECT LIMPRODAF.CDPRODUTO FROM LIMPRODAF WHERE LIMPRODAF.CDOPERADOR = :P_CDOPERADOR AND LIMPRODAF.CDPRODUTO = PRODUTO.CDPRODUTO))";
        $stmt = $this->con->prepare($verificacao);
        $stmt->execute($params);
        $retornaVericacao = $stmt->fetchAll();
      
        if (is_array($retornaVericacao) && count($retornaVericacao)) {
            $sql = "INSERT INTO LIMPRODAF (CDOPERADOR,CDPRODUTO, VRLIMPRODAF, VRLIMPRAFMES) SELECT SUBSTR(:P_CDOPERADOR,1,255) AS CDOPERADOR, PRODUTO.CDPRODUTO, :P_VRLIMPRODAF, :P_VRLIMPRAFMES FROM (SELECT PRODUTO.*, 'SEG' AS IDTPPRODUTO FROM NIVELPRODSEG, PRODUTO, FILIAL, PRODUTO P WHERE P.CDPRODUTO = NIVELPRODSEG.CDPRODUTO AND FILIAL.CDSEGMER = NIVELPRODSEG.CDSEGMER AND FILIAL.CDFILIAL = :P_CDFILIAL AND PRODUTO.CDARVPROD LIKE P.CDARVPROD || '%' AND NOT EXISTS (SELECT CDPRODUTO FROM ROTFABRICA WHERE ROTFABRICA.CDPRODUTO = PRODUTO.CDPRODUTO) AND NOT EXISTS (SELECT CDPRODUTO FROM ROTFABLOCAL WHERE CDFILIAL = :P_CDFILIAL AND ROTFABLOCAL.CDPRODUTO = PRODUTO.CDPRODUTO) UNION ALL SELECT PRODUTO.*, 'PROD' AS IDTPPRODUTO FROM FILIAL, PRODUTO WHERE FILIAL.CDSEGMER IS NULL AND FILIAL.CDFILIAL = :P_CDFILIAL AND NOT EXISTS (SELECT CDPRODUTO FROM ROTFABRICA WHERE ROTFABRICA.CDPRODUTO = PRODUTO.CDPRODUTO) AND NOT EXISTS (SELECT CDPRODUTO FROM ROTFABLOCAL WHERE CDFILIAL = :P_CDFILIAL AND ROTFABLOCAL.CDPRODUTO = PRODUTO.CDPRODUTO)) PRODUTO WHERE PRODUTO.CDARVPROD BETWEEN :P_CDPRODUTOINI AND :P_CDPRODUTOFIN AND PRODUTO.CDPRODESTO IS NOT NULL AND (EXISTS (SELECT PRODCOMP.CDPRODUTO FROM PRODCOMP, PRODUTO A WHERE A.CDPRODUTO = PRODCOMP.CDPRODUTO AND PRODCOMP.CDOPERADOR = :P_CDOPERADOR AND PRODUTO.CDARVPROD LIKE A.CDARVPROD || '%')) AND (NOT EXISTS (SELECT LIMPRODAF.CDPRODUTO FROM LIMPRODAF WHERE LIMPRODAF.CDOPERADOR = :P_CDOPERADOR AND LIMPRODAF.CDPRODUTO = PRODUTO.CDPRODUTO))";
            $stmt = $this->con->prepare($sql);
            $stmt->execute($params);
        } else {
            $prodsExists = self::verifyProdExists($row);
            
            if (is_array($prodsExists) && count($prodsExists)) {
                throw new \Exception('Limite por Produto informado já cadastrado.');
            }else{
                throw new \Exception('Produto não cadastrado para o comprador.');
            }
        }
        
    }
    public function verificaNivelProduto(DTO\Request $request, DTO\Response $response){
        $row = $request->getDataSet()->getRows();
        $sql = "SELECT CDPRODUTO FROM PRODUTO WHERE CDPRODUTO = :P_CDPRODUTO AND CDNVPRODUTO < (SELECT MAX(CDNVPRODUTO) FROM PRODUTO)";
        $params = array();      //inicializa params como um array
        $params['P_CDPRODUTO'] = $row[0]['CDPRODUTO'];
       
        
        $stmt = $this->con->prepare($sql); //preparando a conexão
        $stmt->execute($params);
        $retorno = $stmt->fetchAll();
        $response->addDataSet(new DataSet("resp", $retorno));
    }
    public function fornecedorUtilizaAceite(DTO\Request $request, DTO\Response $response){
        $sql = "SELECT CDFORNECED FROM FORNECEDOR WHERE IDUTLCTRLTERMO = 'S'";
        
        $stmt = $this->con->prepare($sql); //preparando a conexão
        $stmt->execute();
        $retorno = $stmt->fetchAll();
        $response->addDataSet(new DataSet("resp", $retorno));
    }
    public function verifyProdExists($row){
        $params = array();
        
        $params['P_CDFILIAL']     = $row['CDFILIAL'];
        $params['P_CDOPERADOR']   = $row['CDOPERADOR'];
        $params['P_CDPRODUTOINI'] = $row['CDPRODINI'];
        $params['P_CDPRODUTOFIN'] = $row['CDPRODFIN'] = self::strPadRigthProd($row['CDPRODFIN']);
        $params['P_VRLIMPRODAF']  = $row['VRLIMPRODAF'];
        $params['P_VRLIMPRAFMES'] = $row['VRLIMPRAFMES'];
        try {
            $sql = "SELECT SUBSTR(:P_CDOPERADOR,1,255) AS CDOPERADOR, PRODUTO.CDPRODUTO, :P_VRLIMPRODAF, :P_VRLIMPRAFMES FROM ( SELECT PRODUTO.*, 'SEG' AS IDTPPRODUTO FROM NIVELPRODSEG, PRODUTO, FILIAL, PRODUTO P WHERE P.CDPRODUTO = NIVELPRODSEG.CDPRODUTO AND FILIAL.CDSEGMER = NIVELPRODSEG.CDSEGMER AND FILIAL.CDFILIAL =:P_CDFILIAL AND PRODUTO.CDARVPROD LIKE P.CDARVPROD || '%' AND NOT EXISTS ( SELECT CDPRODUTO FROM ROTFABRICA WHERE ROTFABRICA.CDPRODUTO = PRODUTO.CDPRODUTO ) AND NOT EXISTS ( SELECT CDPRODUTO FROM ROTFABLOCAL WHERE CDFILIAL =:P_CDFILIAL AND ROTFABLOCAL.CDPRODUTO = PRODUTO.CDPRODUTO ) UNION ALL SELECT PRODUTO.*, 'PROD' AS IDTPPRODUTO FROM FILIAL, PRODUTO WHERE FILIAL.CDSEGMER IS NULL AND FILIAL.CDFILIAL =:P_CDFILIAL AND NOT EXISTS ( SELECT CDPRODUTO FROM ROTFABRICA WHERE ROTFABRICA.CDPRODUTO = PRODUTO.CDPRODUTO ) AND NOT EXISTS ( SELECT CDPRODUTO FROM ROTFABLOCAL WHERE CDFILIAL =:P_CDFILIAL AND ROTFABLOCAL.CDPRODUTO = PRODUTO.CDPRODUTO ) ) PRODUTO WHERE PRODUTO.CDARVPROD BETWEEN :P_CDPRODUTOINI AND :P_CDPRODUTOFIN AND PRODUTO.CDPRODESTO IS NOT NULL AND ( EXISTS ( SELECT PRODCOMP.CDPRODUTO FROM PRODCOMP, PRODUTO A WHERE A.CDPRODUTO = PRODCOMP.CDPRODUTO AND PRODCOMP.CDOPERADOR =:P_CDOPERADOR AND PRODUTO.CDARVPROD LIKE A.CDARVPROD || '%' ) )";
            $std = $this->con->prepare($sql);
            $std->execute($params);
            return $std->fetchAll();
        } catch (Exception $e){
            throw $e;
        }
    }
    protected $reportMapping = array ();
    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response){
        $row = $request->getRow();
        $lcomp = '';
        $this->birtStrategy->setReportFormat(strtolower($row['QR2TYPE']));
        if($row['STRATEGY'] == 'BIRT'){
        $row['BIRTTYPE'] = $row['QR2TYPE'];
        unset($row['QR2TYPE']);
        }
        $this->stNomeRel = $this->getReportName($row);
        if($row['ALLCOMPREL'] !== 'T'){
        $ope = implode("_", $row['CDOPERADOR']);
        $row['ALLCOMPREL'] = $this->criarListaValores($ope);
        }
        $row['P_NRORG'] = $this->environment->getNrOrg();
        $this->reportMapping[$this->stNomeRel] =
        array (
            'strategy' => $row['STRATEGY'],
            'parameterMapping' => 
            array (
                'CDPRODINI'  => 'P_CDPRODINI',
                'CDPRODFIN'  => 'P_CDPRODFIM',
                'NMPRODINI'  => 'P_NMPRODINI',
                'NMPRODFIN'  => 'P_NMPRODFIM',
                'ALLCOMPREL' => 'L_COMP',
                'P_NRORG'    => 'P_NRORG'
                
            ),
        );
    }
    protected function criarListaValores($lista){
        $nrlista = $this->newCode->getCodeByTableName('LISTA', $this->environment->getNrOrg());
        $valores = explode('_',$lista);
        try{
            foreach($valores as $key){
                $this->insertLista($nrlista, $key);
            }
            return $nrlista;
        } catch(\Exception $e){
            throw $e;
        }
    }
    public function insertLista($nrlista, $cdlista){
        $params = array(
            "NRLISTA" => $nrlista,
            "CDLISTA" => $cdlista
        );

        $sql = "INSERT INTO LISTA (NRLISTA, CDLISTA) VALUES (:NRLISTA, :CDLISTA)";
        $query = $this->connection->prepare($sql);
        $query->execute($params);
    }
}
